/*
 ## Cypress FX3 Camera Kit header file (sensor.h)
 ## ===========================
 ##
 ##  Copyright Cypress Semiconductor Corporation, 2010-2012,
 ##  All Rights Reserved
 ##  UNPUBLISHED, LICENSED SOFTWARE.
 ##
 ##  CONFIDENTIAL AND PROPRIETARY INFORMATION
 ##  WHICH IS THE PROPERTY OF CYPRESS.
 ##
 ##  Use of this file is governed
 ##  by the license agreement included in the file
 ##
 ##     <install>/license/license.txt
 ##
 ##  where <install> is the Cypress software
 ##  installation root directory path.
 ##
 ## ===========================
*/

/* This file defines the parameters and the interface for the image sensor driver. */
#define PAN_UP_CTR          1
#define PAN_DOWN_CTR		2
#define PAN_LEFT_CTR		3
#define PAN_RIGHT_CTR		4
#define ZOOM_TELE_CTR   	5
#define ZOOM_WIDE_CTR		6
#define PAN_SPEED			7
#define TILI_SPEED			8


#define PAN_SPEED_MIN	0
#define PAN_SPEED_MAX	0x17
#define PAN_SPEED_DEF	12//0x05

#define TILI_SPEED_MIN	0
#define TILI_SPEED_MAX	0x13
#define TILI_SPEED_DEF	10

#define VALUE_1	0x1
#define VALUE_0	0x0


#define PAN_TILT_DIRECTIONR    5
#define PAN_TILT_DIR_UP		   1
#define PAN_TILT_DIR_DOWN		2
#define PAN_TILT_DIR_LEFT		3
#define PAN_TILT_DIR_RIGHT		4
#define PAN_TILT_DIR_STOP		5
#define PAN_TILT_DIR_HOME		6

#define ZOOM_TELE	2
#define ZOOM_WIDE	3
#define ZOOM_STOP	0

#define INFO_SUPPORTS_SET (1 << 1);

#define FPGA_I2C_HEADER_1   0xe2
#define FPGA_I2C_ID_1       0x00



#define I2C_WR_SIZE			32
#define I2C_RD_SIZE			32


//#define DEBUG_PTZ

/*[]*/

