#include "common.h"

#ifdef DEF_DBG
int read_cur_value;
#endif
#if defined(CONFIG_CAM_BRI_MIN)
static void brightness_control(void)
{
	uint8_t byData[] = {0xE2, 0x00, 0x81, 0x09, 0x04, 0xa0, 0x01, 0xFF};
//	uint8_t byData[] = {0xc0,0xca,0x8a,0x7e};//ѭ͸鿴fx3 TXǷݷ
	uint16_t BriVal;
	uint8_t bSendData = 0;
	CyU3PReturnStatus_t apiRetStatus = CY_U3P_SUCCESS;
	uint16_t readCount = 0;
	switch (g_bRequest)
	{
		case CY_FX_USB_UVC_GET_LEN_REQ: /* Length of brightness data = 1 byte. */
			glEp0Buffer[0] = 2;
			CyU3PUsbSendEP0Data(1, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_CUR_REQ: /* Current brightness value. */
			datarw_write(byData, sizeof(byData));
#ifdef DEF_DBG
			read_cur_value = 6;
#endif
#if 0
			while(1)
			{
				datarw_write(byData, sizeof(byData));
				CyU3PThreadSleep(50);
			}
#endif//ѭͲѯfx3 RX armǷݷ
			if(datarw_read(g_byReadBuffer, 9, 2, byData[5], byData[6]))
			{
				BriVal = (g_byReadBuffer[6] << 4) | g_byReadBuffer[7];
				DPINFO(3, "%d, brightness g_byReadBuffer[6] [7] = %X %X\r\n", __LINE__, g_byReadBuffer[6], g_byReadBuffer[7]);
			}
			else
				BriVal = CONFIG_CAM_BRI_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MIN_REQ:
			BriVal = CONFIG_CAM_BRI_MIN;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MAX_REQ:
			BriVal = CONFIG_CAM_BRI_MAX;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_RES_REQ:
			BriVal = 1;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_INFO_REQ: /* Both GET and SET requests are supported, auto modes not supported */
			BriVal = 0x03;
			glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(BriVal);
			CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_DEF_REQ: /* Default brightness value = 55. */
			BriVal = CONFIG_CAM_BRI_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_SET_CUR_REQ: /* Update brightness value. */
			apiRetStatus = CyU3PUsbGetEP0Data(CY_FX_UVC_MAX_PROBE_SETTING_ALIGNED, glEp0Buffer, &readCount);
			if(apiRetStatus == CY_U3P_SUCCESS)
			{
				uint8_t byData[] = {0xE2, 0x00, 0x81, 0x01, 0x04, 0xA1, 0x00, 0x00, 0xFF, 0xFF, 0xFF};
				byData[8] = (glEp0Buffer[0] & 0xf0)>>4;
				byData[9] = glEp0Buffer[0] & 0x0f;
				CyU3PThreadSleep(30);//Ĭֵòȷ
				datarw_write(byData, sizeof(byData));
				CyU3PThreadSleep(30);//Ĭֵòȷ
			}
			break;
		default:
			CyU3PUsbStall (0, CyTrue, CyFalse);
			break;
	}
	if (bSendData)
	{
		glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(BriVal);
		glEp0Buffer[1] = CY_U3P_DWORD_GET_BYTE1(BriVal);
		CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
	}
}

#endif//

#if defined(CONFIG_CAM_CON_MIN)
static void contrast_control(void)
{
	uint8_t byData[] = {0xE2, 0x00, 0x81, 0x09, 0x04, 0xa1, 0x01, 0xFF};
	uint16_t ConVal;
	uint8_t bSendData = 0;
	CyU3PReturnStatus_t apiRetStatus = CY_U3P_SUCCESS;
	uint16_t readCount = 0;
	switch (g_bRequest)
	{
		case CY_FX_USB_UVC_GET_LEN_REQ: /* Length of brightness data = 1 byte. */
			glEp0Buffer[0] = 1;
			CyU3PUsbSendEP0Data(1, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_CUR_REQ: /* Current brightness value. */
			datarw_write(byData, sizeof(byData));
			if(datarw_read(g_byReadBuffer, 9, 2, byData[5], byData[6]))
			{
				ConVal = (g_byReadBuffer[6] << 4) | g_byReadBuffer[7];
				DPINFO(3, "%d, contrast g_byReadBuffer[6] [7] = %X %X\r\n", __LINE__, g_byReadBuffer[6], g_byReadBuffer[7]);
			}
			else
				ConVal = CONFIG_CAM_CON_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MIN_REQ:
			ConVal = CONFIG_CAM_CON_MIN;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MAX_REQ:
			ConVal = CONFIG_CAM_CON_MAX;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_RES_REQ:
			ConVal = 1;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_INFO_REQ: /* Both GET and SET requests are supported, auto modes not supported */
			ConVal = 3;
			glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(ConVal);
			CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_DEF_REQ: /* Default brightness value = 55. */
			ConVal = CONFIG_CAM_CON_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_SET_CUR_REQ: /* Update brightness value. */
			apiRetStatus = CyU3PUsbGetEP0Data(CY_FX_UVC_MAX_PROBE_SETTING_ALIGNED, glEp0Buffer, &readCount);
			if(apiRetStatus == CY_U3P_SUCCESS)
			{
				uint8_t byData[] = {0xE2, 0x00, 0x81, 0x01, 0x04, 0xA2, 0x00, 0x00, 0xFF, 0xFF, 0xFF};
				byData[8] = (glEp0Buffer[0] & 0xf0)>>4;
				byData[9] = glEp0Buffer[0] & 0x0f;
				CyU3PThreadSleep(30);//Ĭֵòȷ
				datarw_write(byData, sizeof(byData));
				CyU3PThreadSleep(30);//Ĭֵòȷ
			}
			break;
		default:
			CyU3PUsbStall (0, CyTrue, CyFalse);
			break;
	}
	if (bSendData)
	{
		glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(ConVal);
		glEp0Buffer[1] = CY_U3P_DWORD_GET_BYTE1(ConVal);
		CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
	}
}
#endif //
#if defined(CONFIG_CAM_HUE_MIN)
static void hue_control(void)
{
	uint8_t byData[] = {0xE2, 0x00, 0x81, 0x09, 0x04, 0xa2, 0x01, 0xFF};
	uint16_t HueVal;
	uint8_t bSendData = 0;
	CyU3PReturnStatus_t apiRetStatus = CY_U3P_SUCCESS;
	uint16_t readCount = 0;
	switch (g_bRequest)
	{
		case CY_FX_USB_UVC_GET_LEN_REQ: /* Length of brightness data = 1 byte. */
			glEp0Buffer[0] = 1;
			CyU3PUsbSendEP0Data(1, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_CUR_REQ: /* Current brightness value. */
			datarw_write(byData, sizeof(byData));
			if(datarw_read(g_byReadBuffer, 9, 2, byData[5], byData[6]))
			{
				HueVal = (g_byReadBuffer[6] << 4) | g_byReadBuffer[7];
				DPINFO(3, "%d, hue g_byReadBuffer[6] [7] = %X %X\r\n", __LINE__, g_byReadBuffer[6], g_byReadBuffer[7]);
			}
			else
				HueVal = CONFIG_CAM_HUE_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MIN_REQ:
			HueVal = CONFIG_CAM_HUE_MIN;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MAX_REQ:
			HueVal = CONFIG_CAM_HUE_MAX;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_RES_REQ: /* Resolution = 1. */
			HueVal = 1;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_INFO_REQ: /* Both GET and SET requests are supported, auto modes not supported */
			HueVal = 3;
			glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(HueVal);
			CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_DEF_REQ: /* Default brightness value = 55. */
			HueVal = CONFIG_CAM_HUE_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_SET_CUR_REQ: /* Update brightness value. */
			apiRetStatus = CyU3PUsbGetEP0Data(CY_FX_UVC_MAX_PROBE_SETTING_ALIGNED, glEp0Buffer, &readCount);
			if(apiRetStatus == CY_U3P_SUCCESS)
			{
				uint8_t byData[] = {0xE2, 0x00, 0x81, 0x01, 0x04, 0x4F, 0x00, 0x00, 0xFF, 0xFF, 0xFF};
				byData[8] = (glEp0Buffer[0] & 0xf0)>>4;
				byData[9] = glEp0Buffer[0] & 0x0f;
				CyU3PThreadSleep(30);//Ĭֵòȷ
				datarw_write(byData, sizeof(byData));
				CyU3PThreadSleep(30);//Ĭֵòȷ
			}
			break;
		default:
			CyU3PUsbStall (0, CyTrue, CyFalse);
			break;
	}
	if (bSendData)
	{
		glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(HueVal);
		glEp0Buffer[1] = CY_U3P_DWORD_GET_BYTE1(HueVal);
		CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
	}
}
#endif

#if defined(CONFIG_CAM_SAT_MIN)
static void saturation_control(void)
{
	uint8_t byData[] = {0xE2, 0x00, 0x81, 0x09, 0x04, 0xa3, 0x01, 0xFF};
	uint16_t SatVal;
	uint8_t bSendData = 0;
	CyU3PReturnStatus_t apiRetStatus = CY_U3P_SUCCESS;
	uint16_t readCount = 0;
	switch (g_bRequest)
	{
		case CY_FX_USB_UVC_GET_LEN_REQ: /* Length of brightness data = 1 byte. */
			glEp0Buffer[0] = 1;
			CyU3PUsbSendEP0Data(1, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_CUR_REQ: /* Current brightness value. */
			datarw_write(byData, sizeof(byData));
			if(datarw_read(g_byReadBuffer, 9, 2, byData[5], byData[6]))
			{
				SatVal  = (g_byReadBuffer[6] << 4) | g_byReadBuffer[7];
				DPINFO(3, "%d, saturation g_byReadBuffer[6] [7] = %X %X\r\n", __LINE__, g_byReadBuffer[6], g_byReadBuffer[7]);
			}
			else
				SatVal = CONFIG_CAM_SAT_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MIN_REQ: /* ѯǰϢֻһ */
			SatVal = CONFIG_CAM_SAT_MIN;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MAX_REQ: /* Maximum brightness = 255. */
			SatVal = CONFIG_CAM_SAT_MAX;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_RES_REQ: /* Resolution = 1. */
			SatVal = 1;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_INFO_REQ: /* Both GET and SET requests are supported, auto modes not supported */
			SatVal = 3;
			glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(SatVal);
			CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_DEF_REQ: /* Default brightness value = 55. */
			SatVal = CONFIG_CAM_SAT_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_SET_CUR_REQ: /* Update brightness value. */
			apiRetStatus = CyU3PUsbGetEP0Data(CY_FX_UVC_MAX_PROBE_SETTING_ALIGNED, glEp0Buffer, &readCount);
			if(apiRetStatus == CY_U3P_SUCCESS)
			{
				uint8_t byData[] = {0xE2, 0x00, 0x81, 0x01, 0x04, 0x49, 0x00, 0x00, 0xFF, 0xFF, 0xFF};
				byData[8] = (glEp0Buffer[0] & 0xf0)>>4;
				byData[9] = glEp0Buffer[0] & 0x0f;
				CyU3PThreadSleep(30);//Ĭֵòȷ
				datarw_write(byData, sizeof(byData));
				CyU3PThreadSleep(30);//Ĭֵòȷ
			}
			break;
		default:
			CyU3PUsbStall (0, CyTrue, CyFalse);
			break;
	}

	if (bSendData)
	{
		glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(SatVal);
		glEp0Buffer[1] = CY_U3P_DWORD_GET_BYTE1(SatVal);
		CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
	}
}
#endif //

#if defined(CONFIG_CAM_SHARPNESS_MIN)
static void sharpness_control(void)
{
	uint8_t byData[] = {0xE2, 0x00, 0x81, 0x09, 0x04, 0xa4, 0x01, 0xFF};
	uint16_t ShaVal;
	uint8_t bSendData = 0;
	switch (g_bRequest)
	{
		case CY_FX_USB_UVC_GET_LEN_REQ: /* Length of brightness data = 1 byte. */
			glEp0Buffer[0] = 1;
			CyU3PUsbSendEP0Data(1, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_CUR_REQ: /* Current brightness value. */
			datarw_write(byData, sizeof(byData));
			if(datarw_read(g_byReadBuffer, 9, 2, byData[5], byData[6]))
			{
				ShaVal = (g_byReadBuffer[6] << 4) | g_byReadBuffer[7];
				DPINFO(3, "%d, sharpnes g_byReadBuffer[6] [7] = %X %X\r\n", __LINE__, g_byReadBuffer[6], g_byReadBuffer[7]);
			}
			else
				ShaVal = CONFIG_CAM_SHARPNESS_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MIN_REQ: /* ѯǰϢֻһ */
			ShaVal = CONFIG_CAM_SHARPNESS_MIN;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MAX_REQ: /* Maximum brightness = 255. */
			ShaVal = CONFIG_CAM_SHARPNESS_MAX;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_RES_REQ: /* Resolution = 1. */
			ShaVal = 1;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_INFO_REQ: /* Both GET and SET requests are supported, auto modes not supported */
			ShaVal = 3;
			glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(ShaVal);
			CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_DEF_REQ: /* Default brightness value = 55. */
			ShaVal = CONFIG_CAM_SHARPNESS_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_SET_CUR_REQ: /* Update brightness value. */
			{
				CyU3PReturnStatus_t apiRetStatus = CY_U3P_SUCCESS;
				uint16_t readCount = 0;
				apiRetStatus = CyU3PUsbGetEP0Data(CY_FX_UVC_MAX_PROBE_SETTING_ALIGNED, glEp0Buffer, &readCount);
				if(apiRetStatus == CY_U3P_SUCCESS)
				{
					uint8_t byData[] = {0xE2, 0x00, 0x81, 0x01, 0x04, 0x42, 0x00, 0x00, 0xFF, 0xFF, 0xff};
					byData[8] = (glEp0Buffer[0] & 0xf0)>>4;
					byData[9] = glEp0Buffer[0] & 0x0f;
					CyU3PThreadSleep(30);//Ĭֵòȷ
					datarw_write(byData, sizeof(byData));
					CyU3PThreadSleep(30);//Ĭֵòȷ
				}
			}
			break;
		default:
			CyU3PUsbStall (0, CyTrue, CyFalse);
			break;
	}

	if (bSendData)
	{
		glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(ShaVal);
		glEp0Buffer[1] = CY_U3P_DWORD_GET_BYTE1(ShaVal);
		CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
	}
}
#endif

#if defined(CONFIG_CAM_GAMMA_MIN)
static void gamma_control(void)
{
	uint8_t byData[] = {0xE2, 0x00, 0x81, 0x09, 0x04, 0xa5, 0x01, 0xFF};
	uint16_t GamVal;
	uint8_t bSendData = 0;
	CyU3PReturnStatus_t apiRetStatus = CY_U3P_SUCCESS;
	uint16_t readCount = 0;
	switch (g_bRequest)
	{
		case CY_FX_USB_UVC_GET_LEN_REQ: /* Length of brightness data = 1 byte. */
			glEp0Buffer[0] = 1;
			CyU3PUsbSendEP0Data(1, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_CUR_REQ: /* Current brightness value. */
			datarw_write(byData, sizeof(byData));
			if(datarw_read(g_byReadBuffer, 8, 2, byData[5], byData[6]))
			{
				GamVal = g_byReadBuffer[6];
				DPINFO(3, "%d, gamma g_byReadBuffer[6]=%X\r\n", __LINE__, g_byReadBuffer[6]);
			}
			else
				GamVal = CONFIG_CAM_GAMMA_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MIN_REQ: /* ѯǰϢֻһ */
			GamVal = CONFIG_CAM_GAMMA_MIN;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MAX_REQ: /* Maximum brightness = 255. */
			GamVal = CONFIG_CAM_GAMMA_MAX;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_RES_REQ: /* Resolution = 1. */
			GamVal = 1;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_INFO_REQ: /* Both GET and SET requests are supported, auto modes not supported */
			GamVal = 3;
			glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(GamVal);
			CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_DEF_REQ: /* Default brightness value = 55. */
			GamVal = CONFIG_CAM_GAMMA_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_SET_CUR_REQ: /* Update brightness value. */
			apiRetStatus = CyU3PUsbGetEP0Data(CY_FX_UVC_MAX_PROBE_SETTING_ALIGNED, glEp0Buffer, &readCount);
			if(apiRetStatus == CY_U3P_SUCCESS)
			{
				uint8_t byData[] = {0xE2, 0x00, 0x81, 0x01, 0x04, 0x5B, 0xFF, 0xFF};
				byData[6] = glEp0Buffer[0];
				CyU3PThreadSleep(30);//Ĭֵòȷ
				datarw_write(byData, sizeof(byData));
				CyU3PThreadSleep(30);//Ĭֵòȷ
			}
			break;
		default:
			CyU3PUsbStall (0, CyTrue, CyFalse);
			break;
	}
	if (bSendData)
	{
		glEp0Buffer[0] = CY_U3P_DWORD_GET_BYTE0(GamVal);
		glEp0Buffer[1] = CY_U3P_DWORD_GET_BYTE1(GamVal);
		CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
	}
}
#endif //

#if defined(CONFIG_CAM_POWERLINE_DEF)
static void powerline_control(void)
{
	uint8_t byData[] = {0xE2, 0x00, 0x81, 0x09, 0x04, 0xa6, 0x01, 0xFF};
	uint16_t PowVal;
	uint8_t bSendData = 0;
	switch (g_bRequest)
	{
		case CY_FX_USB_UVC_GET_LEN_REQ: /* Length of brightness data = 1 byte. */
			glEp0Buffer[0] = 1;
			CyU3PUsbSendEP0Data(1, (uint8_t *)glEp0Buffer);
			break;
		case CY_FX_USB_UVC_GET_CUR_REQ: /* Current brightness value. */
			datarw_write(byData, sizeof(byData));
			if(datarw_read(g_byReadBuffer, 8, 2, byData[5], byData[6]))
			{
				PowVal = g_byReadBuffer[6];
				DPINFO(3, "%d, powline g_byReadBuffer[6]=%X\r\n", __LINE__, g_byReadBuffer[6]);
			}
			else
				PowVal = CONFIG_CAM_POWERLINE_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MIN_REQ:  //ѯǰϢֻһ
			PowVal = CONFIG_CAM_POWERLINE_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_MAX_REQ:  //Maximum brightness = 255.
			PowVal = CONFIG_CAM_POWERLINE_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_RES_REQ:  //Resolution = 1.
			PowVal = CONFIG_CAM_POWERLINE_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_INFO_REQ: // Both GET and SET requests are supported, auto modes not supported
			PowVal = 3;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_GET_DEF_REQ: // Default brightness value = 55.
			PowVal = CONFIG_CAM_POWERLINE_DEF;
			bSendData = 1;
			break;
		case CY_FX_USB_UVC_SET_CUR_REQ: // Update brightness value.
			{
				CyU3PReturnStatus_t apiRetStatus = CY_U3P_SUCCESS;
				uint16_t readCount = 0;
				apiRetStatus = CyU3PUsbGetEP0Data(CY_FX_UVC_MAX_PROBE_SETTING_ALIGNED, glEp0Buffer, &readCount);
				if(apiRetStatus == CY_U3P_SUCCESS)
				{
					uint8_t byData[] = {0xE2, 0x00, 0x81, 0x01, 0x04, 0x23, 0xFF, 0xFF};
					byData[6] = glEp0Buffer[0];
					datarw_write(byData, sizeof(byData));
//					CyU3PThreadSleep(3);
				}
			}
			break;
		default:
			CyU3PUsbStall (0, CyTrue, CyFalse);
			break;
	}
	if (bSendData)
	{
		glEp0Buffer[0] = PowVal;
		CyU3PUsbSendEP0Data(g_wLength, (uint8_t *)glEp0Buffer);
	}
}
#endif

void UVCHandleProcessingUnitRqts(void)
{
	switch(g_wValue)
{
#if defined(CONFIG_CAM_BRI_MIN)
	case CY_FX_UVC_PU_BRIGHTNESS_CONTROL:
		brightness_control();
		break;
#endif//CONFIG_CAM_BRI_MIN

#if defined(CONFIG_CAM_CON_MIN)
	case CY_FX_UVC_PU_CONTRAST_CONTROL:
		contrast_control();
		break;
#endif//CONFIG_CAM_CON_MIN

#if defined(CONFIG_CAM_HUE_MIN)
	case CY_FX_UVC_PU_HUE_CONTROL:
		hue_control();
		break;
#endif//CONFIG_CAM_HUE_MIN

#if defined(CONFIG_CAM_SAT_MIN)
	case CY_FX_UVC_PU_SATURATION_CONTROL:
		saturation_control();
		break;
#endif//CONFIG_CAM_SAT_MIN

#if defined(CONFIG_CAM_SHARPNESS_MIN)
	case CY_FX_UVC_PU_SHARPNESS_CONTROL:
		sharpness_control();
		break;
#endif//CONFIG_CAM_SHARPNESS_MIN

#if defined(CONFIG_CAM_GAMMA_MIN)
	case CY_FX_UVC_PU_GAMMA_CONTROL:
		gamma_control();
		break;
#endif//CONFIG_CAM_GAMMA_MIN

#if defined(CONFIG_CAM_POWERLINE_DEF)
	case CY_FX_UVC_PU_POWER_LINE_FREQUENCY_CONTROL:
		powerline_control();
		break;
#endif//CONFIG_CAM_POWERLINE_DEF

	default:
		CyU3PUsbStall (0, CyTrue, CyFalse);
		break;
	}
}
